#include <stdio.h>

int main() {
    int n, k, temp=1;
    scanf("%d %d",&n,&k);
    while(k && temp<=n) {
        if(n%temp==0) {
            k--;
        }
        if(k==0) break;
        temp++;
    }

    if(k==0) printf("%d",temp);
    else printf("0");

    return 0;
}